commit 75508baf13ece3e1748bbd94699394595796897d
Author: Marek Lovčí <mareklovci@gmail.com>
Date:   Thu Jun 4 07:08:41 2020 +0200

    Merge origin/develop into master

diff --git a/app/Http/Controllers/ArtefactController.php b/app/Http/Controllers/ArtefactController.php
index 8f18ee1..a09aba7 100644
--- a/app/Http/Controllers/ArtefactController.php
+++ b/app/Http/Controllers/ArtefactController.php
@@ -5,63 +5,197 @@ namespace App\Http\Controllers;
 use App\Artefact;
 use App\ArtefactCategory;
 use App\Category;
-use Illuminate\Http\Request;
-use Illuminate\Support\Facades\DB;
+use App\User;
+use Illuminate\Contracts\View\Factory;
+use Illuminate\Http\RedirectResponse;
+use Illuminate\Support\Facades\Auth;
+use Illuminate\View\View;
 
 class ArtefactController extends Controller
 {
+    const ORDER_COLUMN = 'page';
+
     public function __construct()
     {
         $this->middleware('auth');
     }
 
+    /**
+     * Prepare all necessary data for shown Artefact.
+     * These are current count of likes, if it set to
+     * a favorites by a logged user and all metadata
+     * connected to the artefact.
+     *
+     * @param       $artefacts  all artefacts
+     * @return      mixed       modified artefacts
+     */
+    public function prepData($artefacts)
+    {
+        foreach($artefacts as $artefact)
+        {
+            $artefact['likes'] = Artefact::find($artefact->id)->users()->count();
+            $artefact['favourite'] = is_null(User::find(Auth::id())->likesArtefacts()->find($artefact->id)) ? false : true;
+            $metadata = Artefact::find($artefact->id)->metadata()->orderBy(self::ORDER_COLUMN)->get();
+
+            foreach ($metadata as $item)
+            {
+                $item['favourite'] = is_null(User::find(Auth::id())->likesMetadata()->find($item->id)) ? false : true;
+            }
+
+            $artefact['metadata'] = $metadata;
+        }
+
+        return $artefacts;
+    }
+
     /**
      * Returns view of all artefacts.
      *
-     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
+     * @return Factory|View
      */
     public function default()
     {
-        $artefacts = Artefact::all();
-
+        $artefacts = Artefact::simplePaginate(1);
+        $artefacts = $this->prepData($artefacts);
         return view('artefact.default', ['artefacts' => $artefacts]);
     }
 
     /**
      * Returns view of artefacts related to the chosen category
      *
-     * @param $id       id of the category
-     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
+     * @param $id id of the category
+     * @return Factory|View
      */
     public function showCategory($id)
     {
-        $cateogryArtefacts = ArtefactCategory::where('category_id', $id)->get();
-        if(count($cateogryArtefacts) > 0)
+        $artefacts = Category::find($id)->artefacts()->simplePaginate(1);
+        $artefacts = $this->prepData($artefacts);
+        return view('artefact.default', ['artefacts' => $artefacts]);
+    }
+
+    /**
+     * Returns view of artefacts related to the chosen categories
+     *
+     * @param $id string with categories ids
+     * @return Factory|View
+     */
+    public function showCategories($id)
+    {
+        //Parsing text for individual ids of categories
+        $textWithIds  = $id;
+        $pieces = explode(",", $textWithIds);
+        $arrStrToInt = array();
+        for($i = 0;$i < count($pieces); $i++)
         {
-            $artefacts = array();
-            foreach($cateogryArtefacts as $ar)
+            if($pieces[$i] == null || !strcmp($pieces[$i], ""))
             {
-                array_push($artefacts, Artefact::where('id', $ar->artefact_id)->get());
+                continue;
             }
-            return view('artefact.category', ['artefacts' => $artefacts]);
+
+            array_push($arrStrToInt, (int)$pieces[$i]);
         }
-        else
+
+        //Creating array of all artefacts ids
+        $arrArtIds = array();
+        foreach($arrStrToInt as $cat)
         {
-            return view('artefact.category', ['artefacts' => array()]);
+            $tmpArtefacts = Category::find($cat)->artefacts()->get();
+            foreach($tmpArtefacts as $art)
+            {
+                array_push($arrArtIds, $art->id);
+            }
         }
+
+        $artefacts = Artefact::whereIn('id', $arrArtIds)->simplePaginate(1);
+        $artefacts = $this->prepData($artefacts);
+        return view('artefact.default', ['artefacts' => $artefacts]);
     }
 
     /**
      * Returns view of single artefact given by its id.
      *
      * @param $id int id of the artefact
-     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
+     * @return Factory|View
      */
     public function view($id)
     {
+        $artefact = Artefact::where('id', $id)->simplePaginate(1);
+        $artefact = $this->prepData($artefact);
+        //return view('artefact.view', ['artefact' => $artefact]);
+        return view('artefact.default', ['artefacts' => $artefact]);
+    }
+
+    /**
+     * Likes artefact given by its id.
+     *
+     * @param $id int id of metadata
+     * @return RedirectResponse
+     */
+    public function like($id)
+    {
+        $user = User::find(Auth::id());
+        $artefact = Artefact::find($id);
+
+        $user->likesArtefacts()->attach($artefact);
+
+        return back()->withInput();
+    }
+
+    /**
+     * Unlikes artefact given by its id.
+     *
+     * @param $id int id of metadata
+     * @return RedirectResponse
+     */
+    public function unlike($id)
+    {
+        $user = User::find(Auth::id());
         $artefact = Artefact::find($id);
-        $artefact['likes'] = Artefact::find($id)->users()->count();
 
-        return view('artefact.view', ['artefact' => $artefact]);
+        $user->likesArtefacts()->detach($artefact);
+
+        return back()->withInput();
     }
+
+    /**
+     * Returns artefact given by its id.
+     *
+     * @param $id int id of artefact
+     * @return RedirectResponse
+     */
+    /*public function view($id)
+    {
+        //$user = User::find(Auth::id());
+        //$artefact = Artefact::find($id);
+
+        $artefacts = Artefact::withCount('users')->orderByDesc('users_count')->get()->take(10);
+
+
+            $currentPage = -1; // You can set this to any page you want to paginate to
+
+            for($i=0;$i<10;$i++){
+                if($artefacts[$i]->id==$id) $currentPage = $i+1;
+            }
+            // Make sure that you call the static method currentPageResolver()
+            // before querying users
+            \Illuminate\Pagination\Paginator::currentPageResolver(function () use ($currentPage) {
+                return $currentPage;
+            });
+
+
+
+        $artefacts = Artefact::withCount('users')->orderByDesc('users_count')->limit(10)->paginate(1);
+
+        $artefacts = ArtefactController::prepData($artefacts);
+        return view('artefact.default', ['artefacts' => $artefacts]);
+        /*foreach($artefacts as $item)
+        {
+            $id = $item->id;
+            $item['likes'] = Artefact::find($id)->users()->count();
+            $item['favourite'] = is_null(User::find(Auth::id())->likesArtefacts()->find($id)) ? false : true;
+        }*/
+
+
+        //return back()->withInput();
+    /*}*/
 }
diff --git a/app/Http/Controllers/Auth/RegisterController.php b/app/Http/Controllers/Auth/RegisterController.php
index 3746d74..d6ff69f 100644
--- a/app/Http/Controllers/Auth/RegisterController.php
+++ b/app/Http/Controllers/Auth/RegisterController.php
@@ -3,10 +3,13 @@
 namespace App\Http\Controllers\Auth;
 
 use App\Http\Controllers\Controller;
+use App\Mail\RegisterMail;
 use App\Providers\RouteServiceProvider;
 use App\User;
+use Illuminate\Routing\UrlGenerator;
 use Illuminate\Foundation\Auth\RegistersUsers;
 use Illuminate\Support\Facades\Hash;
+use Illuminate\Support\Facades\Mail;
 use Illuminate\Support\Facades\Validator;
 
 class RegisterController extends Controller
@@ -64,12 +67,18 @@ class RegisterController extends Controller
      */
     protected function create(array $data)
     {
-        //dd($data);
+        $stringH = Hash::make($data['email'] . $data['name']);
+        $vowels = array("/", "\\");
+        $stringHModified = str_replace($vowels, "", $stringH);
+
+        //Mail::to($data['email'])->send(new RegisterMail("http://localhost/verify/". $stringHModified));
+        Mail::to($data['email'])->send(new RegisterMail(url("/verify/") . "/" . $stringHModified));//http://localhost/register/verify/..
 
         return User::create([
             'name' => $data['name'],
             'email' => $data['email'],
             'password' => Hash::make($data['password']),
+            'register_hash' => $stringHModified,
         ]);
     }
 }
diff --git a/app/Http/Controllers/ChartsController.php b/app/Http/Controllers/ChartsController.php
new file mode 100644
index 0000000..20686d1
--- /dev/null
+++ b/app/Http/Controllers/ChartsController.php
@@ -0,0 +1,55 @@
+<?php
+
+namespace App\Http\Controllers;
+
+use App\User;
+use Illuminate\Contracts\Foundation\Application;
+use Illuminate\Contracts\View\Factory;
+use Illuminate\Http\RedirectResponse;
+use Illuminate\Support\Facades\Auth;
+use App\Http\Controllers\Image;
+use Illuminate\View\View;
+use App\Artefact;
+
+class ChartsController extends Controller
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+    }
+
+    /**
+     * Display a listing of the resource.
+     *
+     * @return Application|Factory|View
+     */
+    public function index()
+    {
+        if(Auth::check())
+        {
+            $artefacts = Artefact::withCount('users')->orderByDesc('users_count')->get()->take(10);
+            foreach($artefacts as $item)
+            {
+                $id = $item->id;
+                $item['likes'] = Artefact::find($id)->users()->count();
+                $item['favourite'] = is_null(User::find(Auth::id())->likesArtefacts()->find($id)) ? false : true;
+            }
+
+            $data = array(
+                'title' => 'Charts',
+                'artefacts' => $artefacts
+            );
+            return view('charts.index') -> with($data);
+        }
+        else
+        {
+            $data = array(
+                'title' => 'Welcome to the MERLOT page',
+            );
+            //return view('index', compact('title'));
+            return view('pages.index') -> with($data);
+        }
+    }
+
+
+}
diff --git a/app/Http/Controllers/DetailsController.php b/app/Http/Controllers/DetailsController.php
index c9e45f5..4cef5e3 100644
--- a/app/Http/Controllers/DetailsController.php
+++ b/app/Http/Controllers/DetailsController.php
@@ -3,12 +3,16 @@
 namespace App\Http\Controllers;
 
 use App\ArtefactUser;
+use App\User;
 use Illuminate\Http\Request;
 use App\Metadata;
 use App\Artefact;
+use Illuminate\Support\Facades\Auth;
 
 class DetailsController extends Controller
 {
+    const ORDER_COLUMN = 'page';
+
     public function __construct()
     {
         $this->middleware('auth');
@@ -32,17 +36,53 @@ class DetailsController extends Controller
      * Display the specified resource.
      *
      * @param  int  $id
-     * @return \Illuminate\Http\Response
+     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
      */
     public function show($id)
     {
-        $data = array(
-            'id' => $id,
-            'arrArtefact' => Artefact::find($id),
-            'likes' => Artefact::find($id)->users()->count(),
-            'metadata' => Metadata::where('artefact_id', $id)->get()
-        );
-        return view('detail.index') -> with($data);
+        if (is_null(Artefact::find($id)))
+        {
+            return view('detail.index', ['metadata' => []]);
+        }
+
+        $metadata = Artefact::find($id)->metadata()->orderBy(self::ORDER_COLUMN)->get();
+        foreach($metadata as $item)
+        {
+            $item['favourite'] = is_null(User::find(Auth::id())->likesMetadata()->find($item->id)) ? false : true;
+        }
+
+        return view('detail.index', ['metadata' => $metadata]);
     }
 
+    /**
+     * Likes metadata given by its id.
+     *
+     * @param $id int id of metadata
+     * @return \Illuminate\Http\RedirectResponse
+     */
+    public function like($id)
+    {
+        $user = User::find(Auth::id());
+        $metadata = Metadata::find($id);
+
+        $user->likesMetadata()->attach($metadata);
+
+        return back()->withInput();
+    }
+
+    /**
+     * Unlikes metadata given by its id.
+     *
+     * @param $id int id of metadata
+     * @return \Illuminate\Http\RedirectResponse
+     */
+    public function unlike($id)
+    {
+        $user = User::find(Auth::id());
+        $metadata = Metadata::find($id);
+
+        $user->likesMetadata()->detach($metadata);
+
+        return back()->withInput();
+    }
 }
diff --git a/app/Http/Controllers/FavoriteArtefactsController.php b/app/Http/Controllers/FavoriteArtefactsController.php
index c9b62ac..6d050d5 100644
--- a/app/Http/Controllers/FavoriteArtefactsController.php
+++ b/app/Http/Controllers/FavoriteArtefactsController.php
@@ -2,49 +2,65 @@
 
 namespace App\Http\Controllers;
 
-use App\ArtefactUser;
+use Illuminate\Contracts\Foundation\Application;
+use Illuminate\Contracts\View\Factory;
 use Illuminate\Support\Facades\Auth;
 use App\User;
 use App\Artefact;
 use App\Http\Controllers\Image;
+use Illuminate\View\View;
 
 class FavoriteArtefactsController extends Controller
 {
+    const ORDER_COLUMN = 'page';
+
     public function __construct()
     {
         $this->middleware('auth');
     }
 
+    /**
+     * Prepare all necessary data for shown Artefact.
+     * These are current count of likes, if it set to
+     * a favorites by a logged user and all metadata
+     * connected to the artefact.
+     *
+     * @param       $artefacts  all artefacts
+     * @return      mixed       modified artefacts
+     */
+    public function prepData($artefacts)
+    {
+        foreach($artefacts as $artefact)
+        {
+            $artefact['likes'] = Artefact::find($artefact->id)->users()->count();
+            $artefact['favourite'] = is_null(User::find(Auth::id())->likesArtefacts()->find($artefact->id)) ? false : true;
+            $metadata = Artefact::find($artefact->id)->metadata()->orderBy(self::ORDER_COLUMN)->get();
+            foreach ($metadata as $item)
+            {
+                $item['favourite'] = is_null(User::find(Auth::id())->likesMetadata()->find($item->id)) ? false : true;
+            }
+            $artefact['metadata'] = $metadata;
+        }
+        return $artefacts;
+    }
+
     /**
      * Display a listing of the resource.
      *
-     * @return \Illuminate\Http\Response
+     * @return Application|Factory|View
      */
     public function index()
     {
         if(Auth::check())
         {
             $id = Auth::id();
-            $artefacts = User::find($id)->likesArtefacts()->get();
-            foreach($artefacts as $item)
-            {
-                $item['likes'] = Artefact::find($item->id)->users()->count();
-            }
-
-            $data = array(
-                'title' => 'Favorite artefacts',
-                'user' => $id,
-                'artefacts' => $artefacts
-            );
-            return view('favartefacts.index') -> with($data);
+            $artefacts = User::find($id)->likesArtefacts()->simplePaginate(1);
+            $artefacts = $this->prepData($artefacts);
+            return view('artefact.default', ['artefacts' => $artefacts]);
         }
         else
         {
-            $data = array(
-                'title' => 'Welcome to the MERLOT page',
-            );
-            //return view('index', compact('title'));
-            return view('pages.index') -> with($data);
+            return view('pages.index');
         }
     }
 
@@ -52,25 +68,13 @@ class FavoriteArtefactsController extends Controller
      * Display the specified resource.
      *
      * @param  int  $id
-     * @return \Illuminate\Http\Response
+     * @return Application|Factory|View
      */
     public function show($id)
     {
-        $artefacts = User::find($id)->likesArtefacts()->get();
-        foreach($artefacts as $item)
-        {
-            $item['likes'] = Artefact::find($item->id)->users()->count();
-        }
-
-
-        $data = array(
-            'title' => 'Favorite artefacts',
-            'id' => $id,
-            'user' => User::find($id),
-            'userId' => Auth::id(),
-            'artefacts' => $artefacts
-        );
-        return view('favartefacts.index') -> with($data);
+        $artefacts = User::find($id)->likesArtefacts()->simplePaginate(1);
+        $artefacts = $this->prepData($artefacts);
+        return view('artefact.default', ['artefacts' => $artefacts]);
     }
 
 }
diff --git a/app/Http/Controllers/FavoriteMetadataController.php b/app/Http/Controllers/FavoriteMetadataController.php
index 0597ec7..00b5369 100644
--- a/app/Http/Controllers/FavoriteMetadataController.php
+++ b/app/Http/Controllers/FavoriteMetadataController.php
@@ -16,6 +16,11 @@ class FavoriteMetadataController extends Controller
         $this->middleware('auth');
     }
 
+    /**
+     * Show list of favourite metadata.
+     *
+     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
+     */
     public function index()
     {
         $metadata = User::find(Auth::id())->likesMetadata()->orderBy(self::ORDER_COLUMN)->get();
@@ -27,4 +32,20 @@ class FavoriteMetadataController extends Controller
         return view('favmetadata.index', ['metadata' => $metadata]);
     }
 
+    /**
+     * Unlike metadata given by its id.
+     *
+     * @param $id int id of metadata
+     * @return \Illuminate\Http\RedirectResponse
+     */
+    public function unlike($id)
+    {
+        $user = User::find(Auth::id());
+        $metadata = Metadata::find($id);
+
+        $user->likesMetadata()->detach($metadata);
+
+        return back()->withInput();
+    }
+
 }
diff --git a/app/Http/Controllers/VerifyRegisterController.php b/app/Http/Controllers/VerifyRegisterController.php
new file mode 100644
index 0000000..a061fb7
--- /dev/null
+++ b/app/Http/Controllers/VerifyRegisterController.php
@@ -0,0 +1,58 @@
+<?php
+
+
+namespace App\Http\Controllers;
+
+
+use App\User;
+use Illuminate\Contracts\View\Factory;
+use Illuminate\View\View;
+
+class VerifyRegisterController extends Controller
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+    }
+
+    /**
+     * Verify registration link with time and user database,
+     * if the user exists. If everything checks out, the user's
+     * account will be activated.
+     *
+     * @param $id string hash of created user
+     * @return Factory|View
+     */
+    public function verifyUser($id)
+    {
+        $userV = User::where('register_hash', $id)->get();
+        $text = "";
+        if(!$userV->isEmpty())
+        {
+            $created = $userV[0]->created_at;
+            $now = date('Y-m-d h:i:s');
+            $interval = $created->diff($now);
+
+            if($interval->d >= 2)
+            {
+                $text = "Registration link expired!\n Need to create new account";
+                $userV[0]->delete();
+            }
+            else if(isset($userV[0]->email_verified_at))
+            {
+                $text = "Registration link already activated!";
+            }
+            else
+            {
+                $userV[0]->email_verified_at = date('Y-m-d h:i:s');
+                $userV[0]->save();
+                $text = "Registration of the user " . $userV[0]->name . " has been successful.";
+            }
+        }
+        else
+        {
+            $text = "The link is not valid!";
+        }
+        return view('verify.index', ['text' => $text]);
+    }
+}
diff --git a/app/Http/Kernel.php b/app/Http/Kernel.php
index c3640f3..5af7425 100644
--- a/app/Http/Kernel.php
+++ b/app/Http/Kernel.php
@@ -17,6 +17,8 @@ class Kernel extends HttpKernel
         \App\Http\Middleware\TrustProxies::class,
         \Fruitcake\Cors\HandleCors::class,
         \App\Http\Middleware\CheckForMaintenanceMode::class,
+        //\Illuminate\Session\Middleware\StartSession::class,
+        //\Illuminate\View\Middleware\ShareErrorsFromSession::class,
         \Illuminate\Foundation\Http\Middleware\ValidatePostSize::class,
         \App\Http\Middleware\TrimStrings::class,
         \Illuminate\Foundation\Http\Middleware\ConvertEmptyStringsToNull::class,
diff --git a/app/Mail/RegisterMail.php b/app/Mail/RegisterMail.php
new file mode 100644
index 0000000..cca8861
--- /dev/null
+++ b/app/Mail/RegisterMail.php
@@ -0,0 +1,35 @@
+<?php
+
+namespace App\Mail;
+
+use Illuminate\Bus\Queueable;
+use Illuminate\Contracts\Queue\ShouldQueue;
+use Illuminate\Mail\Mailable;
+use Illuminate\Queue\SerializesModels;
+
+class RegisterMail extends Mailable
+{
+    use Queueable, SerializesModels;
+
+    public $stringHash;
+
+    /**
+     * Create a new message instance.
+     *
+     * @return void
+     */
+    public function __construct($stringH)
+    {
+        $this->stringHash = $stringH;
+    }
+
+    /**
+     * Build the message.
+     *
+     * @return $this
+     */
+    public function build()
+    {
+        return $this->markdown('email.register');
+    }
+}
diff --git a/app/User.php b/app/User.php
index da5cf4a..469eec2 100644
--- a/app/User.php
+++ b/app/User.php
@@ -20,7 +20,7 @@ class User extends Authenticatable
      * @var array
      */
     protected $fillable = [
-         'name', 'email', 'password'
+         'name', 'email', 'password', 'register_hash'
     ];
 
     /**
diff --git a/database/factories/ArtefactFactory.php b/database/factories/ArtefactFactory.php
index f074539..14366ea 100644
--- a/database/factories/ArtefactFactory.php
+++ b/database/factories/ArtefactFactory.php
@@ -10,7 +10,7 @@ use Illuminate\Database\Eloquent\Factory;
 
 $factory->define(Artefact::class, function ($faker) {
     return [
-        'name' => $faker->opera,
+        'name' => $faker->words($nb = 3, $asText = true),
         'author' => $faker->name,
         'made_in' => $faker->countryCode,
         'publisher' => $faker->company,
diff --git a/database/factories/UserFactory.php b/database/factories/UserFactory.php
index e9cbede..d0835e1 100644
--- a/database/factories/UserFactory.php
+++ b/database/factories/UserFactory.php
@@ -27,5 +27,6 @@ $factory->define(User::class, function (Faker $faker) {
         'remember_token' => Str::random(10),
         'created_at' => now(),
         'updated_at' => now(),
+        'register_hash' => Str::random(10),
     ];
 });
diff --git a/database/migrations/2020_04_06_000000_CreateUsersTable.php b/database/migrations/2020_04_06_000000_CreateUsersTable.php
index 89604d6..a7bdd89 100644
--- a/database/migrations/2020_04_06_000000_CreateUsersTable.php
+++ b/database/migrations/2020_04_06_000000_CreateUsersTable.php
@@ -23,6 +23,7 @@ class CreateUsersTable extends Migration
             $table->string('password');
             $table->rememberToken();
             $table->timestamps();
+            $table->string('register_hash');
         });
     }
 
diff --git a/database/seeds/DatabaseSeeder.php b/database/seeds/DatabaseSeeder.php
index d971dd6..bb769ec 100644
--- a/database/seeds/DatabaseSeeder.php
+++ b/database/seeds/DatabaseSeeder.php
@@ -21,6 +21,7 @@ class DatabaseSeeder extends Seeder
             'remember_token' => Str::random(10),
             'created_at' => now(),
             'updated_at' => now(),
+            'register_hash' => Str::random(10),
         ]);
 
         // Populate users
diff --git a/public/js/app.js b/public/js/app.js
index fb62752..1f5a858 100644
--- a/public/js/app.js
+++ b/public/js/app.js
@@ -37057,11 +37057,21 @@ __webpack_require__(/*! ./bootstrap */ "./resources/js/bootstrap.js"); // Center
 
 $(document).ready(function () {
   var display_width = $(window).width();
-  $(".metadata").each(function () {
-    var metadata = $(this);
-    var width = metadata.width();
-    metadata.css("margin-left", display_width / 2 - width);
-  });
+
+  if (display_width < 720) {
+    $(".metadata").each(function () {
+      var metadata = $(this);
+      var width = metadata.width();
+      metadata.css("margin-left", display_width / 2 - width);
+    });
+  } else {
+    display_width = $(".metadata-area").width();
+    $(".metadata").each(function () {
+      var metadata = $(this);
+      var width = metadata.width();
+      metadata.css("margin-left", display_width / 2 - width);
+    });
+  }
 });
 
 /***/ }),
diff --git a/resources/js/app.js b/resources/js/app.js
index d6dd869..0923ec8 100644
--- a/resources/js/app.js
+++ b/resources/js/app.js
@@ -4,11 +4,24 @@ require('./bootstrap');
 $(document).ready(function () {
     let display_width = $(window).width();
 
-    $(".metadata").each(function() {
-        let metadata = $(this);
-        let width = metadata.width();
+    if (display_width < 720)
+    {
+        $(".metadata").each(function() {
+            let metadata = $(this);
+            let width = metadata.width();
 
-        metadata.css("margin-left", (display_width / 2)  - width);
-    });
+            metadata.css("margin-left", (display_width / 2)  - width);
+        });
+    }
+    else
+    {
+        display_width = $(".metadata-area").width();
 
+        $(".metadata").each(function() {
+            let metadata = $(this);
+            let width = metadata.width();
+
+            metadata.css("margin-left", (display_width / 2)  - width);
+        });
+    }
 });
diff --git a/resources/lang/cs/general.php b/resources/lang/cs/general.php
new file mode 100644
index 0000000..c5f72ef
--- /dev/null
+++ b/resources/lang/cs/general.php
@@ -0,0 +1,24 @@
+<?php
+
+return [
+
+    /*
+    |--------------------------------------------------------------------------
+    | Login Page Language Lines
+    |--------------------------------------------------------------------------
+    */
+
+    'email' => 'e-mail',
+    'password' => 'heslo',
+    'join' => 'vstoupit',
+
+    /*
+    |--------------------------------------------------------------------------
+    | Error Page Language Lines
+    |--------------------------------------------------------------------------
+    */
+
+    'not_found' => 'Stránka nenalezena',
+    'server_error' => 'Něco se pokazilo',
+
+];
diff --git a/resources/lang/en/general.php b/resources/lang/en/general.php
new file mode 100644
index 0000000..fad59ad
--- /dev/null
+++ b/resources/lang/en/general.php
@@ -0,0 +1,57 @@
+<?php
+
+return [
+
+    /*
+    |--------------------------------------------------------------------------
+    | General Language Lines
+    |--------------------------------------------------------------------------
+    */
+
+    'kaplicky' => 'kaplicky',
+
+    /*
+    |--------------------------------------------------------------------------
+    | Sidebar Language Lines
+    |--------------------------------------------------------------------------
+    */
+
+    'cs' => 'česky',
+    'en' => 'english',
+
+    /*
+    |--------------------------------------------------------------------------
+    | Sidebar Language Lines
+    |--------------------------------------------------------------------------
+    */
+
+    'home' => 'home',
+    'login' => 'login',
+    'logout' => 'logout',
+    'register' => 'register',
+    'topics' => 'topics',
+    'artefacts' => 'books',
+    'favourite_artefacts' => 'likes',
+    'favourite_metadata' => 'notes',
+    'charts' => 'best of',
+
+    /*
+    |--------------------------------------------------------------------------
+    | Login Page Language Lines
+    |--------------------------------------------------------------------------
+    */
+
+    'email' => 'e-mail',
+    'password' => 'password',
+    'join' => 'join',
+
+    /*
+    |--------------------------------------------------------------------------
+    | Error Page Language Lines
+    |--------------------------------------------------------------------------
+    */
+
+    'not_found' => 'Not Found',
+    'server_error' => 'Internal Server Error',
+
+];
diff --git a/resources/views/artefact/default.blade.php b/resources/views/artefact/default.blade.php
index ac565b8..800d804 100644
--- a/resources/views/artefact/default.blade.php
+++ b/resources/views/artefact/default.blade.php
@@ -9,46 +9,6 @@
 
 
 @section('content')
-    <div class="container">
-        <div class="jumbotron mt-5">
-            <div class="text-center">
-                <h1>Artefact list</h1>
-                <p>
-                    Lorem ipsum dolor sit amet, consectetuer adipiscing elit.
-                    Mauris dolor felis, sagittis at, luctus sed, aliquam non, tellus.
-                    Fusce tellus odio, dapibus id fermentum quis, suscipit id erat.
-                    Morbi scelerisque luctus velit. Vivamus porttitor turpis ac leo.
-                    Morbi scelerisque luctus velit.
-                    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.
-                </p>
-            </div>
-        </div>
-
-        @if (count($artefacts) === 0)
-            <div class="text-center">
-                <h2>Currently no artefacts available.</h2>
-            </div>
-        @else
-            @foreach ($artefacts as $artefact)
-                <div class="artefacts-area mb-5">
-                    <div class="card">
-                        <svg class="bd-placeholder-img card-img-top" width="100%" height="180" xmlns="http://www.w3.org/2000/svg" preserveAspectRatio="xMidYMid slice" focusable="false" role="img" aria-label="Placeholder: Image cap"><title>Placeholder</title><rect width="100%" height="100%" fill="#868e96"></rect><text x="45%" y="50%" fill="#dee2e6" dy=".3em">Artefact image</text></svg>
-                        <div class="card-body">
-                            <h5 class="card-title"><a href="{{ url('/artefact/' . $artefact->id) }}">{{$artefact->name}}</a> - {{$artefact->author}}</h5>
-                            <h6 class="card-subtitle mb-2 text-muted">{{$artefact->year}}, {{$artefact->pages}} pages</h6>
-                            <p class="card-text">
-                                Lorem ipsum dolor sit amet, consectetuer adipiscing elit.
-                                Mauris dolor felis, sagittis at, luctus sed, aliquam non, tellus.
-                                Fusce tellus odio, dapibus id fermentum quis, suscipit id erat.
-                                Morbi scelerisque luctus velit. Vivamus porttitor turpis ac leo.
-                                Morbi scelerisque luctus velit.
-                                Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.
-                            </p>
-                        </div>
-                    </div>
-                </div>
-            @endforeach
-        @endif
-    </div>
-
+    @component('components/books', ['artefacts' => $artefacts])
+    @endcomponent
 @endsection
